"use strict";

var callOnce = function callOnce(handler) {
    var result;

    var _wrappedHandler = function wrappedHandler() {
        result = handler.apply(this, arguments);
        _wrappedHandler = function wrappedHandler() {
            return result;
        };
        return result;
    };

    return function () {
        return _wrappedHandler.apply(this, arguments);
    };
};

module.exports = callOnce;